/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.pvp.PvPHelper
 *  fire.pb.battle.pvp.PvPResult
 *  fire.pb.circletask.SPVP5MapConfig
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.npc.SGeneralSummonCommand
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.StringConstant
 *  gnet.link.Onlines
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  mkio.Protocol
 *  xtable.Properties
 */
package fire.pb.battle.pvp5;

import fire.pb.battle.pvp.PvPHelper;
import fire.pb.battle.pvp.PvPResult;
import fire.pb.battle.pvp5.PvP5CampPolicy;
import fire.pb.battle.pvp5.PvP5RoleProxy;
import fire.pb.circletask.SPVP5MapConfig;
import fire.pb.main.ConfigManager;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.npc.SGeneralSummonCommand;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.StringConstant;
import gnet.link.Onlines;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import mkdb.Procedure;
import mkdb.Transaction;
import mkio.Protocol;
import xtable.Properties;

public abstract class PvP5Helper
extends PvPHelper {
    public static final int ENTER_MIN_LEVEL = 50;
    public static final int TEAM_MAX_MEMBER_NUM = 5;
    public static final int RACE_MAX_BATTLE_NUM = 100;
    public static final int AWARD_MAX_BATTLE_NUM = 10;
    public static final int CONTINUE_WIN_MIN_NUM = 5;
    public static final long BATTLE_BETWEEN_MILLISECONDS = 5000L;
    public static final long MATCH_WAITING_MILLISECONDS = 31000L;
    public static final int DROP_SCENE_BATTLE_LOSE_NUM = 2;
    public static final int FIRST_WIN_AWARD_ID = 6251;
    public static final int FIVE_FIGHT_AWARD_ID = 6252;
    public static final int RANK_01_05_AWARD_ID = 340010;
    public static final int RANK_06_10_AWARD_ID = 340011;
    public static final int RANK_11_15_AWARD_ID = 340012;
    public static final Map<Integer, Integer[]> TITLE_AWARD_MAP = new HashMap<Integer, Integer[]>();
    private static boolean CHECK_USE_CAMP_POLICY;

    public static Integer[] getTitleAward(int grade) {
        return TITLE_AWARD_MAP.get(grade);
    }

    public static PvPResult checkRoleEnterCondition(long roleId, int grade, int camp, int mapId) {
        Team team = TeamManager.selectTeamByRoleId((long)roleId);
        if (team != null) {
            if (!team.isTeamLeader(roleId) || team.isAbsentMember(roleId)) {
                return new CheckRoleEnterResult(-1, roleId);
            }
            List ids = team.getAllMemberIds();
            int teamSize = ids.size();
            if (teamSize > 5) {
                return new CheckRoleEnterResult(-2, roleId);
            }
            if (ids.size() > 1) {
                Iterator iterator = ids.iterator();
                while (iterator.hasNext()) {
                    long id = (Long)iterator.next();
                    PvP5RoleProxy pvpRoleProxy = PvP5RoleProxy.getPvP5RoleProxy(id, true);
                    if (pvpRoleProxy == null) {
                        return new CheckRoleEnterResult(-10, roleId, id);
                    }
                    int grade2 = pvpRoleProxy.getGradeInActivity();
                    if (grade2 <= 0) {
                        return new CheckRoleEnterResult(-20, roleId, id);
                    }
                    if (grade2 != grade) {
                        return new CheckRoleEnterResult(-30, roleId, id);
                    }
                    if (CHECK_USE_CAMP_POLICY) {
                        PvP5CampPolicy.Policy policy = PvP5CampPolicy.create(id, grade);
                        if (policy == null) {
                            return new CheckRoleEnterResult(-40, roleId, id);
                        }
                        policy.divide();
                        int camp2 = policy.getCamp();
                        int mapId2 = policy.getMapId();
                        if (camp2 != camp) {
                            return new CheckRoleEnterResult(-50, roleId, id);
                        }
                        if (mapId2 == mapId) continue;
                        return new CheckRoleEnterResult(-60, roleId, id);
                    }
                    int camp2 = pvpRoleProxy.getCamp();
                    if (camp2 != camp) {
                        return new CheckRoleEnterResult(-50, roleId, id);
                    }
                    int mapId2 = PvP5Helper.getMapIdByRaceGrade(grade2, pvpRoleProxy.getExcellent() == 1, camp2);
                    if (mapId2 == mapId) continue;
                    return new CheckRoleEnterResult(-60, roleId, id);
                }
            }
        }
        return new CheckRoleEnterResult(0, roleId);
    }

    public static boolean summonByRole(long roleId, int roleMapId) {
        if (PvP5Helper.isPvPMap(roleMapId)) {
            return false;
        }
        int grade = PvP5Helper.getRaceGradeByRoleId(roleId);
        if (grade <= 0) {
            return false;
        }
        SGeneralSummonCommand snd = new SGeneralSummonCommand();
        snd.roleid = 0L;
        snd.mapid = 0;
        snd.minimal = 0;
        snd.summontype = 16;
        if (Transaction.current() != null) {
            Procedure.psendWhileCommit((long)roleId, (Protocol)snd);
        } else {
            Onlines.getInstance().send(Long.valueOf(roleId), (Protocol)snd);
        }
        return true;
    }

    public static Collection<Integer> getAllRaceIds() {
        TreeMap cfgs = ConfigManager.getInstance().getConf(SPVP5MapConfig.class);
        return cfgs.keySet();
    }

    public static int getRaceGradeByRoleId(long roleId) {
        int level = Properties.selectLevel((Long)roleId);
        if (level < 50) {
            return -1;
        }
        return PvP5Helper.getRaceGradeByRoleLevel(level);
    }

    public static int getRaceGradeByRoleLevel(int level) {
        TreeMap confs = ConfigManager.getInstance().getConf(SPVP5MapConfig.class);
        for (Map.Entry entry : confs.entrySet()) {
            if (((SPVP5MapConfig)entry.getValue()).getLevel1() > level || level > ((SPVP5MapConfig)entry.getValue()).getLevel2()) continue;
            return (Integer)entry.getKey();
        }
        return 1;
    }

    public static int getMapIdByRaceGrade(int grade, boolean isExcellent, int camp) {
        SPVP5MapConfig conf = (SPVP5MapConfig)ConfigManager.getInstance().getConf(SPVP5MapConfig.class).get(grade);
        if (conf != null) {
            if (isExcellent) {
                return (Integer)conf.getExcellentMap().get(camp);
            }
            return (Integer)conf.getGeneralMap().get(camp);
        }
        return -1;
    }

    public static int getRaceGradeByMapId(int mapId) {
        TreeMap confs = ConfigManager.getInstance().getConf(SPVP5MapConfig.class);
        for (Map.Entry entry : confs.entrySet()) {
            if (!((SPVP5MapConfig)entry.getValue()).getGeneralMap().contains(mapId) && !((SPVP5MapConfig)entry.getValue()).getExcellentMap().contains(mapId)) continue;
            return (Integer)entry.getKey();
        }
        return -1;
    }

    public static int getExcellentByMapId(int mapId) {
        TreeMap confs = ConfigManager.getInstance().getConf(SPVP5MapConfig.class);
        for (Map.Entry entry : confs.entrySet()) {
            if (((SPVP5MapConfig)entry.getValue()).getGeneralMap().contains(mapId)) {
                return 0;
            }
            if (!((SPVP5MapConfig)entry.getValue()).getExcellentMap().contains(mapId)) continue;
            return 1;
        }
        return 0;
    }

    public static int getCampByMapId(int mapId) {
        TreeMap confs = ConfigManager.getInstance().getConf(SPVP5MapConfig.class);
        for (Map.Entry entry : confs.entrySet()) {
            int index = ((SPVP5MapConfig)entry.getValue()).getGeneralMap().indexOf(mapId);
            if (index < 0) {
                index = ((SPVP5MapConfig)entry.getValue()).getExcellentMap().indexOf(mapId);
            }
            if (index < 0) continue;
            return index;
        }
        return -1;
    }

    public static boolean isPvPMap(int mapId) {
        return PvP5Helper.getRaceGradeByMapId(mapId) != -1;
    }

    public static boolean isSameGrade(long roleId1, long roleId2) {
        int grade2;
        int grade1 = PvP5Helper.getRaceGradeByRoleId(roleId1);
        return grade1 == (grade2 = PvP5Helper.getRaceGradeByRoleId(roleId2));
    }

    public static boolean isSameMap(long roleId1, long roleId2) {
        PvP5RoleProxy pvpRoleProxy1 = PvP5RoleProxy.getPvP5RoleProxy(roleId1, true);
        PvP5RoleProxy pvpRoleProxy2 = PvP5RoleProxy.getPvP5RoleProxy(roleId2, true);
        if (pvpRoleProxy1 == null || pvpRoleProxy2 == null) {
            return false;
        }
        int grade1 = pvpRoleProxy1.getGradeInActivity();
        if (grade1 <= 0) {
            return false;
        }
        int grade2 = pvpRoleProxy2.getGradeInActivity();
        if (grade2 <= 0) {
            return false;
        }
        if (grade1 != grade2) {
            return false;
        }
        if (CHECK_USE_CAMP_POLICY) {
            PvP5CampPolicy.Policy policy1 = PvP5CampPolicy.create(roleId1, grade1);
            PvP5CampPolicy.Policy policy2 = PvP5CampPolicy.create(roleId2, grade2);
            if (policy1 == null || policy2 == null) {
                return false;
            }
            policy1.divide();
            policy2.divide();
            if (policy1.getCamp() != policy2.getCamp()) {
                return false;
            }
            if (policy1.getMapId() != policy2.getMapId()) {
                return false;
            }
        } else {
            int mapId2;
            int camp2;
            int camp1 = pvpRoleProxy1.getCamp();
            if (camp1 != (camp2 = pvpRoleProxy2.getCamp())) {
                return false;
            }
            int mapId1 = PvP5Helper.getMapIdByRaceGrade(grade1, pvpRoleProxy1.getExcellent() == 1, camp1);
            if (mapId1 != (mapId2 = PvP5Helper.getMapIdByRaceGrade(grade2, pvpRoleProxy2.getExcellent() == 1, camp2))) {
                return false;
            }
        }
        return true;
    }

    public static boolean isCanJoinPvPMapTeam(long leaderRoleId, long applyRoleId) {
        Role leaderMapRole = RoleManager.getInstance().getRoleByID(leaderRoleId);
        if (leaderMapRole == null) {
            return false;
        }
        return !PvP5Helper.isPvPMap(leaderMapRole.getMapId()) || PvP5Helper.isSameGrade(leaderRoleId, applyRoleId) && PvP5Helper.isSameMap(leaderRoleId, applyRoleId);
    }

    public static String getGradeName(int grade) {
        switch (grade) {
            case 1: {
                return StringConstant.ID2String((String)"精英组", (int)308);
            }
            case 2: {
                return StringConstant.ID2String((String)"神威组", (int)309);
            }
            case 3: {
                return StringConstant.ID2String((String)"王者组", (int)310);
            }
            case 4: {
                return StringConstant.ID2String((String)"天科组", (int)318);
            }
            case 5: {
                return StringConstant.ID2String((String)"天启组", (int)319);
            }
            case 6: {
                return StringConstant.ID2String((String)"天元组", (int)320);
            }
        }
        return "";
    }

    public static String getCampName(int camp) {
        if (camp == 0) {
            return StringConstant.ID2String((String)"雷毛", (int)311);
        }
        return StringConstant.ID2String((String)"双狼", (int)312);
    }

    static {
        Integer[] t1 = new Integer[]{100, 101, 102, 103, 104};
        Integer[] t2 = new Integer[]{105, 106, 107, 108, 109};
        Integer[] t3 = new Integer[]{110, 111, 112, 113, 114};
        Integer[] t4 = new Integer[]{280, 281, 282, 283, 284};
        Integer[] t5 = new Integer[]{285, 286, 287, 288, 289};
        Integer[] t6 = new Integer[]{290, 291, 292, 293, 294};
        TITLE_AWARD_MAP.put(1, t1);
        TITLE_AWARD_MAP.put(2, t2);
        TITLE_AWARD_MAP.put(3, t3);
        TITLE_AWARD_MAP.put(4, t4);
        TITLE_AWARD_MAP.put(5, t5);
        TITLE_AWARD_MAP.put(6, t6);
        CHECK_USE_CAMP_POLICY = false;
    }

    public static class CheckRoleEnterResult
    extends PvPResult {
        private final long roleId;
        private long errorRoleId = 0L;

        public CheckRoleEnterResult(int result, long roleId) {
            super(result);
            this.roleId = roleId;
        }

        public CheckRoleEnterResult(int result, long roleId, long errorRoleId) {
            super(result);
            this.roleId = roleId;
            this.errorRoleId = errorRoleId;
        }

        public int handle() {
            switch (this.get()) {
                case -1: {
                    MessageMgr.sendMsgNotify((long)this.roleId, (int)141206, null);
                    break;
                }
                case -20: 
                case -10: {
                    String roleName = Properties.selectRolename((Long)this.errorRoleId);
                    for (long id : PvP5RoleProxy.getTeamMemberIds(this.roleId)) {
                        MessageMgr.sendMsgNotify((long)id, (int)172031, (List)MessageMgr.getStringList((Object[])new Object[]{roleName}));
                    }
                    break;
                }
                case -30: {
                    for (long id : PvP5RoleProxy.getTeamMemberIds(this.roleId)) {
                        MessageMgr.sendMsgNotify((long)id, (int)160339, null);
                    }
                    break;
                }
                default: {
                    for (long id : PvP5RoleProxy.getTeamMemberIds(this.roleId)) {
                        MessageMgr.sendMsgNotify((long)id, (int)172028, null);
                    }
                }
            }
            return 0;
        }
    }
}

